/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.CancelacionCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.CancelacionCtrl;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import java.util.Date;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("cancelacionCtrlDAO")
public class CancelacionCtrlHibernateDAO extends GenericHibernateDAO<CancelacionCtrl, Integer>
        implements CancelacionCtrlDAO {

    @Autowired
    public CancelacionCtrlHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<CancelacionCtrl> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    public List<CancelacionCtrl> buscar(Date tiempoprevsalida, PuntoVenta puntoVenta, Parada paradaOrigem,
            Parada paradaDestino, Marca marca) {
        
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.eq("tiempoprevsalida", tiempoprevsalida));
        c.add(Restrictions.eq("puntoVenta", puntoVenta));
        c.add(Restrictions.eq("paradaOrigem", paradaOrigem));
        c.add(Restrictions.eq("paradaDestino", paradaDestino));
        c.add(Restrictions.eq("marca", marca));

        return c.list();
    }
}
